Tree
Time Limit: 1000MS   Memory Limit: 30000K
Total Submissions: 15548   Accepted: 5054

Description

Give a tree with n vertices,each edge has a length(positive integer less than 1001).
Define dist(u,v)=The min distance between node u and v.

Give an integer k,for every pair (u,v) of vertices is called valid if and only if dist(u,v) not exceed k.

Write a program that will count how many pairs which are valid for a given tree.

Input

The
input contains several test cases. The first line of each test case
contains two integers n, k. (n<=10000) The following n-1 lines each
contains three integers u,v,l, which means there is an edge between node
u and v of length l.

The last test case is followed by two zeros.

Output

For each test case output the answer on a single line.

Sample Input

5 4
1 2 3
1 3 1
1 4 2
3 5 1
0 0

Sample Output

8

Source

【思路】

设i到当前root的距离为d[i],i属于belong[i]->belong[i]为当前root的儿子且i在belong[i]为根的树中。设Sum{E}为满足条件E的点对数。

情况分为两种:

    1)      经过根节点

    2)      不经过根节点,在根节点的一颗子树中。

   其中2)可以递归求解。

   对于1)我们要求的是Sum{d[i]+d[j]<=k && belong[i]!=belong[j]},即为

   Sum{d[i]+d[j]<=k}  -  Sum{ d[i]+d[j]<=k && belong[i]==belong[j]}

前后两项都可以转化为求一个序列a中满足d[a[i]]+d[a[j]]<=k的点对数。

先将a按照d值排序,基于单调性,我们可以给出一个O(n)的统计方法。于是问题得到解决。

总的时间复杂度为O(nlog2n)

【代码】

 #include<cstdio>
#include<vector>
#include<cstring>
#include<algorithm>
using namespace std; const int N = +;
const int INF = 1e9; struct Edge{
int u,v,w;
Edge(int u=,int v=,int w=):u(u),v(v),w(w){};
};
int n,K,l1,l2,tl,ans;
int siz[N],d[N],list[N],f[N],can[N];
vector<Edge> es;
vector<int> g[N];
void adde(int u,int v,int w) {
es.push_back(Edge(u,v,w));
int m=es.size(); g[u].push_back(m-);
} void init() {
ans=; es.clear();
memset(can,,sizeof(can));
for(int i=;i<=n;i++) g[i].clear();
}
void dfs1(int u,int fa) {
siz[u]=;
list[++tl]=u;
for(int i=;i<g[u].size();i++) {
int v=es[g[u][i]].v;
if(v!=fa && can[v]) {
dfs1(v,u);
f[v]=u; siz[u]+=siz[v];
}
}
}
int getroot(int u,int fa) { //寻找u子树重心
int pos,mn=INF;
tl=;
dfs1(u,fa);
for(int i=;i<=tl;i++) {
int y=list[i],d=;
for(int j=;j<g[y].size();j++) {
int v=es[g[y][j]].v;
if(v!=f[y] && can[v]) d=max(d,siz[v]);
}
if(y!=u) d=max(d,siz[u]-siz[y]); //上方
if(d<mn) mn=d , pos=y; //使大子结点数最小
}
return pos;
}
void dfs2(int u,int fa,int dis) {
list[++l1]=u; d[u]=dis;
for(int i=;i<g[u].size();i++) {
int v=es[g[u][i]].v;
if(v!=fa && can[v]) dfs2(v,u,dis+es[g[u][i]].w);
}
}
int getans(int* a,int l,int r) {
int res=,j=r;
for(int i=l;i<=r;i++) {
while(d[a[i]]+d[a[j]]>K && j>i) j--;
res+=j-i; if(i==j) break;
}
return res;
}
bool cmp(const int& x,const int& y) { return d[x]<d[y]; }
void solve(int u,int fa) {
int root=getroot(u,fa);
l1=l2=;
for(int i=;i<g[root].size();i++) { //统计 d[i]+d[j]<=K && belong[i]==belong[j]
int v=es[g[root][i]].v;
if(can[v]) {
l2=l1;
dfs2(v,root,es[g[root][i]].w); //insert[以v为根的子树]
sort(list+l2+,list+l1+,cmp);
ans-=getans(list,l2+,l1);
}
}
list[++l1]=root; d[root]=can[root]=;
sort(list+,list+l1+,cmp);
ans+=getans(list,,l1); //统计d[i]+d[j]<=K
for(int i=;i<g[root].size();i++) { //递归<-分治
int v=es[g[root][i]].v;
if(v!=fa && can[v]) solve(v,root);
}
} int main() {
while(scanf("%d%d",&n,&K)== && (n&&K)) {
int u,v,w;
init();
for(int i=;i<n-;i++) {
scanf("%d%d%d",&u,&v,&w);
adde(u,v,w) , adde(v,u,w);
}
solve(,-);
printf("%d\n",ans);
}
return ;
}

poj 1741 Tree(点分治)的更多相关文章

  1. POJ 1741.Tree 树分治 树形dp 树上点对

    Tree Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 24258   Accepted: 8062 Description ...

  2. POJ 1741 Tree 树分治

    Tree     Description Give a tree with n vertices,each edge has a length(positive integer less than 1 ...

  3. [bzoj 1468][poj 1741]Tree [点分治]

    Description Give a tree with n vertices,each edge has a length(positive integer less than 1001). Def ...

  4. POJ 1741 Tree(点分治点对<=k)

    Description Give a tree with n vertices,each edge has a length(positive integer less than 1001). Def ...

  5. POJ 1741 Tree ——点分治

    [题目分析] 这貌似是做过第三道以Tree命名的题目了. 听说树分治的代码都很长,一直吓得不敢写,有生之年终于切掉这题. 点分治模板题目.自己YY了好久才写出来. 然后1A了,开心o(* ̄▽ ̄*)ブ ...

  6. [poj 1741]Tree 点分治

    题意 求树上距离不超过k的点对数,边权<=1000 题解     点分治.     点分治的思想就是取一个树的重心,这种路径只有两种情况,就是经过和不经过这个重心,如果不经过重心就把树剖开递归处 ...

  7. POJ - 1741 - Tree - 点分治 模板

    POJ-1741 题意: 对于带权的一棵树,求树中距离不超过k的点的对数. 思路: 点分治的裸题. 将这棵树分成很多小的树,分治求解. #include <algorithm> #incl ...

  8. poj 1741 Tree(树的点分治)

    poj 1741 Tree(树的点分治) 给出一个n个结点的树和一个整数k,问有多少个距离不超过k的点对. 首先对于一个树中的点对,要么经过根结点,要么不经过.所以我们可以把经过根节点的符合点对统计出 ...

  9. POJ 1741.Tree and 洛谷 P4178 Tree-树分治(点分治,容斥版) +二分 模板题-区间点对最短距离<=K的点对数量

    POJ 1741. Tree Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 34141   Accepted: 11420 ...

  10. POJ 1741 Tree 求树上路径小于k的点对个数)

                                                                                                 POJ 174 ...

随机推荐

  1. eval()字符串转成对象

    var s = "{a:1,b:2}"; console.log(typeof s); s = eval("(" + s + ")"); c ...

  2. 用CSS截断字符串的两种实用方法

    方法一: 复制代码 代码如下: <div style="width:300px; overflow:hidden; text-overflow:ellipsis; white-spac ...

  3. iOS设计模式——委托(delegate)

    委托(delegate)也叫代理是iOS开发中常用的设计模式.我们借助于protocol(参考博文:objective-c协议(protocol))可以很方便的实现这种设计模式. 什么是代理? 苹果的 ...

  4. Qt: qobject_cast<QPushButton*>(sender()) 简化信号与槽的编写

    当你觉得写代码是一件重复性极高的工作时,这时你就应该考虑换个方式来实现了. 提高代码效率,减少代码量. 代码片: void Widget::onClicked() { QPushButton* but ...

  5. SGU111 Very simple problem

    多少个平方数小于等于X,二分. PS:java BigInteger. import java.util.*; import java.math.*; public class Solution { ...

  6. Java API ——Scanner类

    1.Scanner类概述 JDK5以后用于获取用户的键盘输入,一个可以使用正则表达式来解析基本类型和字符串的简单文本扫描器.Scanner 使用分隔符模式将其输入分解为标记,默认情况下该分隔符模式与空 ...

  7. NuGet相关的文章

    NuGet学习笔记(1)——初识NuGet及快速安装使用http://www.cnblogs.com/zhwl/p/3377510.html NuGet学习笔记(2) 使用图形化界面打包自己的类库ht ...

  8. 【HDOJ】1699 The comment in cpp

    注意测试数据12/*hduacm// abcd结果是1/*hduacm// ABCD /* 1699 */ #include <iostream> #include <sstream ...

  9. 函数flst_add_last

    /********************************************************************//** Adds a node as the last no ...

  10. BZOJ3175: [Tjoi2013]攻击装置

    题解: 最大点独立集...好像水过头了... 不过发现我二分图好像忘完了!!! 代码: #include<cstdio> #include<cstdlib> #include& ...